#include <avr/io.h>
#include <util/delay.h>

void ADC_init(void) {
    ADMUX = (1 << REFS0);
    ADCSRA = (1 << ADEN) | (5 << ADPS0);
}

uint16_t ADC_getleft() {
    int channelLEFT = 0;

    ADMUX = (ADMUX & ~(0x1f << MUX0)) | channelLEFT;
    ADCSRA |= (1 << ADSC);
    while(!(ADCSRA & (1 << ADSC)));

    return ADC;
}

uint16_t ADC_getright() {
    int channelRIGHT = 1;

    ADMUX = (ADMUX & ~(0x1f << MUX0)) | channelRIGHT;
    ADCSRA |= (1 << ADSC);
    while(!(ADCSRA & (1 << ADSC)));

    return ADC;
}

int main() {
    /* senzor stanga */
    DDRA &= ~(1 << PA0);
    /* senzor dreapta */
    DDRB &= ~(1 << PB0);

    /* motor stanga */
    DDRA |= (1 << PA2);
    /* motor dreapta */
    DDRB |= (1 << PB3);


    while(1) {

       if (ADC_getleft() == 0 && ADC_getright() == 0) {
            PORTB |= (1 << PB3);
            PORTA |= (1 << PA2);
       }

        if (ADC_getright() != 0)
            PORTB &= ~(1 << PB3);
        else if (ADC_getleft()!= 0) {
            PORTA &= ~(1 << PA2);
        }

        if ((PINB & (1 << PB2)) == 0) {
            PORTB &= ~(1 << PB3);
            PORTA &= ~(1 << PA2);
            break;
        }
        _delay_ms(500);
    }

    return 0;
}